import React from "react";
import PropTypes from "prop-types";
import { connect } from "react-redux";
import LoginForm from "./Login";
import { login,logout } from "../../actionControllers/auth";
import './login.css';

class LoginPage extends React.Component {
  componentDidMount(){
    this.props.logout();
  }

  submit = data =>
    this.props.login(data).then(() => this.props.history.push("/dashboard"));

  render() {
    return (
      <div>
          <h1 className="login-heading">Traffic Rules Violation Detection   </h1>
        <img className="wave" src={`/images/login/wave.png`} alt="Wave" />
        <div className="container-fire-login">
          <div className="img">
              <img src={`https://miro.medium.com/max/1200/1*gtypmrQrBzu0uvLah6YTKQ.gif`} alt="BG"/>
          </div>
          <div className="login-content">
              <LoginForm submit={this.submit} />
          </div>
        </div>
      </div>
    );
  }
}

LoginPage.propTypes = {
  history: PropTypes.shape({
    push: PropTypes.func.isRequired
  }).isRequired,
  login: PropTypes.func.isRequired,
  logout: PropTypes.func.isRequired
};

export default connect(null, { login,logout })(LoginPage);
